// MT Engine MK2
// Copyleft 2014 the Mojon Twins

// Floating objects
// Preliminary version 0.1
// This only works for side-view with bounding box 8 bottom by now.

// TODO: When this is working, cleanup, refactor and optimize!

// Let's go!
// Use a power of 2!
#define MAX_FLOATING_OBJECTS 	8

unsigned char f_o_t [MAX_FLOATING_OBJECTS];
unsigned char f_o_x [MAX_FLOATING_OBJECTS];
unsigned char f_o_y [MAX_FLOATING_OBJECTS];
unsigned char f_o_s [MAX_FLOATING_OBJECTS];

unsigned char fo_it, fo_gp, fo_au, d_prs = 0;
unsigned char fo_idx;
unsigned char fo_x, fo_y, fo_st;

void FO_clear (void) {
	fo_it = 0;
	while (fo_it < MAX_FLOATING_OBJECTS) f_o_t [fo_it ++] = 0;
	fo_idx = 0;
#ifdef ENABLE_FO_CARRIABLE_BOXES			
	p_hasbox = 99;
#ifdef CARRIABLE_BOXES_ALTER_JUMP
	player_max_vy_saltando = PLAYER_MAX_VY_SALTANDO;	
#endif
#endif
	sp_MoveSprAbs (sp_carriable, spritesClip, 0, -2, -2, 0, 0);
}

unsigned char FO_add (unsigned char x, unsigned char y, unsigned char t) {
	f_o_t [fo_idx] = t;
	f_o_x [fo_idx] = x;
	f_o_y [fo_idx] = y;
	f_o_s [fo_idx] = 0;
	fo_idx ++;
	return fo_idx - 1;
}

void FO_paint (unsigned char idx) {
	fo_au = f_o_t [idx];
#ifdef ENABLE_FO_OBJECT_CONTAINERS
	if (fo_au & 128) fo_au = flags [fo_au & 127];
#endif
	if (fo_au == 0) return;
	draw_coloured_tile_gamearea (f_o_x [idx], f_o_y [idx], fo_au);
	// Bit 7 marks this block as "floating". That way the player movement routine can identify it
	// and will never store this location as a "safe" one.
	map_attr [BUFFER_IDX (f_o_x [idx], f_o_y [idx])] = comportamiento_tiles [fo_au] | 128;
}

void FO_unpaint (unsigned char idx) {
	fo_au = BUFFER_IDX (f_o_x [idx], f_o_y [idx]);
	draw_coloured_tile_gamearea (f_o_x [idx], f_o_y [idx], map_buff [fo_au]);
	map_attr [fo_au] = comportamiento_tiles [map_buff [fo_au]];
}

void FO_paint_all (void) {
	fo_it = 0;
	while (fo_it < MAX_FLOATING_OBJECTS) {
		if (f_o_t [fo_it] && fo_it != p_hasbox) FO_paint (fo_it);
		fo_it ++;
	}
}

void FO_do (void) {
		// Make fall
		fo_it = maincounter & (MAX_FLOATING_OBJECTS - 1);

		if (f_o_t [fo_it] && fo_it != p_hasbox && attr (f_o_x [fo_it], f_o_y [fo_it] + 1) < 4) {
			FO_unpaint (fo_it);
			f_o_y [fo_it] ++;
			if (f_o_y [fo_it] == 10) f_o_t [fo_it] = 0; else FO_paint (fo_it);
		}
	
#if defined(ENABLE_FO_CARRIABLE_BOXES) || defined(ENABLE_FO_OBJECT_CONTAINERS)
		fo_y = (gpy >> 4) + 1;
		fo_x = (gpx + 8) >> 4;
		
		// Read keys / controller
		fo_gp = gpit = (joyfunc) (&keys);
		
		if ((fo_gp & sp_DOWN) == 0) {
			if (0 == d_prs) {
				d_prs = 1;
#ifdef ENABLE_FO_CARRIABLE_BOXES			
				if (99 != p_hasbox) {
					// Drop box?
					if ((attr (fo_x, fo_y - 2) & 8) == 0) {
						// revisa esto...
						if (attr (fo_x, fo_y - 1) & 8) {
							if (0 == p_facing) fo_x ++; else fo_x --;
						}
						f_o_y [p_hasbox] = fo_y - 1;
						p_y = (fo_y - 2) << 10;
						f_o_x [p_hasbox] = fo_x;
						FO_paint (p_hasbox);
						p_hasbox = 99;
#ifdef MODE_128K
#else
						peta_el_beeper (2);
#endif
#ifdef CARRIABLE_BOXES_ALTER_JUMP
						// Restore jump
						player_max_vy_saltando = PLAYER_MAX_VY_SALTANDO;
#endif
						sp_MoveSprAbs (sp_carriable, spritesClip, 0, -2, -2, 0, 0);
					}			
				} else 
#endif				
				{
					// Calculate interactuable cell - it depends where the player is facing
					if (0 == p_facing) fo_x = (gpx + 4) >> 4; else fo_x = (gpx + 12) >> 4;		
		
					fo_it = 0;
					while (fo_it < MAX_FLOATING_OBJECTS) {
#ifdef ENABLE_FO_CARRIABLE_BOXES
						if (f_o_y [fo_it] == fo_y && f_o_x [fo_it] == fo_x) {							
							if (f_o_t [fo_it] == FT_CARRIABLE_BOXES) {
								p_hasbox = fo_it;
								FO_unpaint (fo_it);
#ifdef MODE_128K
#else
								peta_el_beeper (2);
#endif
#ifdef CARRIABLE_BOXES_ALTER_JUMP
								// Alter jump
								player_max_vy_saltando = CARRIABLE_BOXES_ALTER_JUMP;
#endif
							}
						}
#endif

#ifdef ENABLE_FO_OBJECT_CONTAINERS
						if (f_o_y [fo_it] == fo_y - 1 && f_o_x [fo_it] == fo_x) {
							if (f_o_t [fo_it] & 128) {
								// Tengo que cambiar lo que haya en items [flags [FT_FLAG_SLOT]]
								// por lo que haya en flags [f_o_t [fo_it] & 127]
								fo_st = f_o_t [fo_it] & 127;
								fo_au = flags [fo_st];
								flags [fo_st] = items [flags [FT_FLAG_SLOT]];
								items [flags [FT_FLAG_SLOT]] = fo_au;
								display_items ();
								if (flags [fo_st]) FO_paint (fo_it); else FO_unpaint (fo_it);
								peta_el_beeper (6);
							}	
						}
#endif									
						fo_it ++;
					}
				} 
			}
		} else {
			d_prs = 0;
		}
		
		// Update sprite?
		if (p_hasbox != 99) sp_MoveSprAbs (sp_carriable, spritesClip, 0, VIEWPORT_Y + (gpy >> 3) - 1, VIEWPORT_X + (gpx >> 3), gpx & 7, gpy & 7);
#endif
}
