@echo off
echo ### MAKING MAP ###
..\utils\map2bin.exe ..\map\mapa.map 6 3 99 map.bin bolts.bin
echo ### MAKING ENEMS ###
..\utils\ene2bin.exe 6 3 1 ..\enems\enems.ene enems.bin hotspots.bin
echo ### MAKING TILESET ###
..\utils\ts2bin.exe ..\gfx\font.png ..\gfx\work.png ts.bin
echo ### MAKING SPRITESET ###
..\utils\sprcnv.exe ..\gfx\sprites.png sprites.h
echo ### MAKING FIXED ###
..\utils\png2scr.exe ..\gfx\title.png ..\gfx\title.scr
..\utils\apack.exe ..\gfx\title.scr title.bin
..\utils\png2scr.exe ..\gfx\ending.png ..\gfx\ending.scr
..\utils\apack.exe ..\gfx\ending.scr ending.bin
echo ### MAKING SPECIAL FIXED ###
..\utils\png2scr.exe ..\gfx\f1.png ..\gfx\f1.scr 2
..\utils\apack.exe ..\gfx\f1.scr f1.bin
..\utils\png2scr.exe ..\gfx\f2.png ..\gfx\f2.scr 2
..\utils\apack.exe ..\gfx\f2.scr f2.bin
..\utils\png2scr.exe ..\gfx\f3.png ..\gfx\f3.scr 2
..\utils\apack.exe ..\gfx\f3.scr f3.bin
..\utils\png2scr.exe ..\gfx\f4.png ..\gfx\f4.scr 2
..\utils\apack.exe ..\gfx\f4.scr f4.bin
..\utils\png2scr.exe ..\gfx\intro.png ..\gfx\fintro.scr 2
..\utils\apack.exe ..\gfx\fintro.scr fintro.bin
del ..\gfx\*.scr
echo ### MAKING LOADING
..\utils\png2scr.exe ..\gfx\loading.png loading.bin
echo ### MAKING SCRIPT ###
..\utils\msc3.exe ..\script\leovigildo.spt 18
echo ### MAKING TEXTS ###
..\utils\textstuffer.exe ..\texts\texts.txt texts.bin 24
echo ### COMPILING ###
zcc +zx -vn leovigildo.c -o leovigildo.bin -lsplib2 -zorg=24200
echo ### MAKING TAPS ###
..\utils\bas2tap -a10 -sLEOVIGILDO loader.bas loader.tap
..\utils\bin2tap -o screen.tap -a 16384 loading.bin
..\utils\bin2tap -o main.tap -a 24200 leovigildo.bin
..\utils\bin2tap -o music.tap -a 63000 song1.bin
copy /b loader.tap + screen.tap + main.tap + music.tap leovigildo.tap
echo ### LIMPIANDO ###
del loader.tap
del screen.tap
del main.tap
del music.tap
del leovigildo.bin
echo ### DONE ###
