@echo off
echo ### MAKING MAP ###
..\utils\map2bin.exe ..\map\mapa.map 5 4 99 map.bin bolts.bin
echo ### MAKING ENEMS ###
..\utils\ene2bin.exe 5 4 1 ..\enems\enems.ene enems.bin hotspots.bin
echo ### MAKING TILESET ###
..\utils\ts2bin.exe ..\gfx\font.png ..\gfx\work.png ts.bin
echo ### MAKING SPRITESET ###
..\utils\sprcnv.exe ..\gfx\sprites.png sprites.h
rem ..\utils\spg2bin.exe ..\gfx\drop.png spdrop.bin
rem ..\utils\spg2bin.exe ..\gfx\arrow.png sparrow.bin
echo ### MAKING FIXED ###
..\utils\png2scr.exe ..\gfx\title.png ..\gfx\title.scr
..\utils\apack.exe ..\gfx\title.scr title.bin
..\utils\png2scr.exe ..\gfx\ending.png ..\gfx\ending.scr
..\utils\apack.exe ..\gfx\ending.scr ending.bin
echo ### MAKING SPECIAL FIXED ###
..\utils\png2scr.exe ..\gfx\fintro1.png ..\gfx\fintro1.scr 2
..\utils\apack.exe ..\gfx\fintro1.scr fintro1.bin
..\utils\png2scr.exe ..\gfx\fintro2.png ..\gfx\fintro2.scr 2
..\utils\apack.exe ..\gfx\fintro2.scr fintro2.bin
del ..\gfx\*.scr
echo ### MAKING LOADING
..\utils\png2scr.exe ..\gfx\loading.png loading.bin
echo ### MAKING SCRIPT ###
..\utils\msc3.exe ..\script\leo3.spt 20
echo ### MAKING TEXTS ###
..\utils\textstuffer.exe ..\texts\texts.txt texts.bin 24
echo ### COMPILING ###
zcc +zx -vn leo3.c -o leo3.bin -lsplib2 -zorg=24200
echo ### MAKING TAPS ###
..\utils\bas2tap -a10 -sDUQUESA loader.bas loader.tap
..\utils\bin2tap -o screen.tap -a 16384 loading.bin
..\utils\bin2tap -o main.tap -a 24200 leo3.bin
..\utils\bin2tap -o music.tap -a 64000 song1.bin
copy /b loader.tap + screen.tap + main.tap + music.tap leo3.tap
echo ### LIMPIANDO ###
del loader.tap
del screen.tap
del main.tap
del leo3.bin
echo ### DONE ###
