// Leovigildo ending sequence.

#define PASS_LENGTH 12
unsigned char *checkto = "CIRCUSMASTER";
unsigned char password [] = "XXXXXXXXXXXX ";
unsigned char esit, esjt;

unsigned char check_password () {
	unsigned char res = 1;
	for (esit = 0; esit < 6; esit ++) {
		if (password [esit] != checkto [esit]) {
			res = 0;
			break;
		}
	}
	
	return res;
}

unsigned char enter_password () {
	print_str (9, 15, 71, "ENTER PASSWORD");

	esjt = 0;
	for (esit = 0; esit < PASS_LENGTH; esit++) password [esit] = '.';
	
	while (1) {
		password [esjt] = '@';
		print_str (10, 17, 71, password);
		sp_UpdateNow ();
		
		do {
			esit = sp_GetKey ();
		} while (!esit);
		peta_el_beeper (6);
		sp_WaitForNoKey ();
		
		if (esit == 12 && esjt > 0) {
			password [esjt] = '.';
			esjt --;
		}
		
		if (esit == 13) break;
		
		if (esit > 'Z') esit -= 32;
		
		if (esit >= 'A' && esit <= 'Z' && esjt < PASS_LENGTH) {
			password [esjt] = esit;
			esjt ++;
		}		
	}
	
	if (check_password ()) return 1;
	
	print_str (9, 15, 71, "    WRONG!    ");
	print_str (21, 17, 71, " ");
	sp_UpdateNow ();
	espera_activa (500);
	
	return 0;
}

const unsigned char ending_sequence [] = {
	200, 4, 5, 6, 7, 201, 8, 9, 10, 11, 202, 12, 13, 14, 203, 0xff
};

void ending_sequence_do (void) {
	esit = 0; is_cutscene = 1;
	do {
		do_extern_action (ending_sequence [esit ++]);
	} while (ending_sequence [esit] != 0xff);
	#asm
		call musicstart
	#endasm
	cuts_clr ();
	do_extern_action (15);
}

void do_ending (void) {
	keys.fire  = 0x10bf; 
	while (1) {
		cortina ();
		print_str (8, 10, 71, ">TIENES LA CLAVE?");
		print_str (9, 12, 71, "1. <CLARO QUE SI!");
		print_str (9, 13, 71, "2. ESTOOO...");
		sp_UpdateNow ();
		while (1) {
			esit = sp_GetKey ();
			if (esit == '1') {
				if  (enter_password ()) {
					// Ending sequence
					ending_sequence_do ();
				}
				break;
			}
			if (esit == '2') {
				// Easter egg!
				cuts_clr ();
				is_cutscene = 0;
				for (esit = 1; esit < 4; esit ++) {
					unpack ((unsigned int) (penter1), 18432);
					do_extern_action (esit);
				}
				return;
			}
		}
	}
}
